﻿using GalaSoft.MvvmLight;
using GalaSoft.MvvmLight.Command;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using WpfApp2_tictactoe.BL;

namespace WpfApp2_tictactoe.VM
{
    class ViewModel : ViewModelBase
    {
        public List<OneField> Fields { get; private set; }

        public int Width { get => TicTacLogic.Single.Width; }
        public int Height { get => TicTacLogic.Single.Height; }
        public event EventHandler GameOver
        {
            add { TicTacLogic.Single.GameOver += value; }
            remove { TicTacLogic.Single.GameOver -= value; }
        }

        public ViewModel()
        {
            Fields = new List<OneField>();
            for(int x = 0; x < TicTacLogic.Single.Width; x++)
            {
                for (int y = 0; y < Height; y++)
                {
                    Fields.Add(new OneField(x, y));
                }
            }
        }
    }

    class OneField : ObservableObject
    {
        private char fieldChar = '-';
        public char FieldChar { get => fieldChar; set => Set(ref fieldChar, value); }

        public ICommand FieldClicked { get; private set; }

        public OneField(int x, int y)
        {
            FieldClicked = new RelayCommand(() => 
            {
                char nextChar = TicTacLogic.Single.PlaceNext(x, y);  
                // Reference to (x,y) parameter => Must use TRUE parameter at the end
                FieldChar = nextChar; // Must write property!
            }, true);
        }


    }
}
